﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using System.Net.Sockets;
using System.Net;
using System.Threading;
using System.IO;
using System.Data.SqlClient;
using System.Data;
using System.Text;
using System.Linq;
using 电源控制;
using System.IO.Ports;
using System.Drawing;
using System.Diagnostics;
using ZedGraph;
namespace server729
{

    public partial class Form1 : Form
    {
        #region 参数设置
        int Vs = 0;
        int Bs = 0;
        long She;
        byte[] chksum = new byte[4];
        byte[] fx = new byte[22];
        long he;
        byte[] SS = new byte [1024];
        string upvolt ="0";
        //string vl;
        string vlh;
        string vll;
       // int t_flag ;    //通讯标志位
        const int maxdy = 4000;             //电压的设置范围
        const int mindy = 10;

        const int maxdl = 50;               //电流的设置范围
        const int mindl = 1;

        const int CID1_h = 0x39;            //CID1
        const int CID1_l = 0x30;

        const int prevolt_h = 0x38;         //发送 设置输出电压 命令
        const int prevolt_l = 0x33;

        const int upvolt_h = 0x38;          //发送 设置电压上限 命令
        const int upvolt_l = 0x31;

        const int upcurr_h = 0x38;          //发送 设置电流上限 命令
        const int upcurr_l = 0x32;

        const int start_h = 0x39;           //发送 启动 命令
        const int start_l = 0x31;

        const int stop_h = 0x39;            //发送 停止 命令
        const int stop_l = 0x32;

        const int state_h = 0x39;           //发送 回读电源状态  命令
        const int state_l = 0x33;

        const int dispfreq_h = 0x39;        //发送 回读电源输出频率  命令
        const int dispfreq_l = 0x34;

        const int disvolt_h = 0x39;         //发送 回读电源输出电压  命令
        const int disvolt_l = 0x35;

        const int dispcurr_h = 0x39;        //发送 回读电源输出电流  命令
        const int dispcurr_l = 0x36;

        const int disppower_h = 0x39;       //发送 回读电源输出功率  命令
        const int disppower_l = 0x37;

        const int dispfact_h = 0x39;        //发送 回读电源输出功率因数  命令
        const int dispfact_l = 0x38;

        const int dispall_h = 0x39;         //发送 回读电源输出功率因数  命令
        const int dispall_l = 0x39;
        #endregion 参数设置
        Random ran = new Random();
        PointPairList list = new PointPairList();
        PointPairList list1 = new PointPairList();
        LineItem myCurve;
        //LineItem myCurve1;
        private System.Timers.Timer timertemp1;
        private System.Timers.Timer timertemp2;
        private System.Timers.Timer timertemp3;
        private System.Timers.Timer timertemp4;
        private System.Timers.Timer timertemp5;
        private System.Timers.Timer timertemp6;
        
        System.DateTime currentTime = System.DateTime.Now;
        Stopwatch mywatch = Stopwatch.StartNew();
        public Form1()
        {

            InitializeComponent();

            TextBox.CheckForIllegalCrossThreadCalls = false;

        }
        Socket sck = null;
        public void wavecongif()
        {
            string[] waves = { "0.01Hz", "0.1Hz", "0.25Hz", "1Hz", "5Hz", "10Hz", "50Hz", "100Hz", };
            foreach (string wave in waves)
            {
                comboBox1.Items.Add(wave);
            }


        }

        //消息框里面数据

        void ShowMsg(string str)
        {

            string Ystr = "";

            if (txt_AccMsg.Text != "")
            {

                Ystr = txt_AccMsg.Text + "\r\n";

            }

            txt_AccMsg.Text = Ystr + str;

        }
        #region 收发信息
        //向客户端发送数据
        #region 发送信息
        private void btn_SendSingleMsg_Click(object sender, EventArgs e)
        {

            string strYMD = currentTime.ToString("yyyy/MM/dd/HH:mm:ss");
            //string sendmg = "#" + strYMD + "#" + textBox2.Text + "#" + textBox1.Text + "#" + textBox5.Text + "#" +
            //    textBox6.Text + "#" + comboBox1.Text + "#" + textBox44.Text + "#" + textBox43.Text + "#" + "33" + "#"
            //    + "20" + "#" + "26" + "#" + "1111" + "#" + "8888" + "#" + "37" + "#" +
            //    "0.02" + "#" + "340" + "#" + textBox16.Text + "#" + textBox17.Text + "#" + textBox18.Text + "#" +
            //    textBox37.Text + "#" + textBox38.Text + "#" + textBox39.Text + "#" +
            //    "100#3.4#25#RUN#STOP#2#1KHz#3#CHE##END#" + "\n";
            string sendmg = "#" + strYMD + "#" + "输出电流" + "#" + "输出电压" + "#" + "输入电流" + "#" +
              "输入电压" + "#" + comboBox1.Text + "#" + "甲板输出A" + "#" + "甲板输出V" + "#" + "发射机变T" + "#"
              + "IGBT" + "#" + "舱内T" + "#" + "离底高度" + "#" + "海水深度" + "#" + "海水T" + "#" +
              "海水盐度" + "#" + "海水声速" + "#" + "AX" + "#" + "AY" + "#" + "AZ" + "#" +
              "BX" + "#" + "BY" + "#" + "BZ" + "#" +
              "绞车揽长#揽速度#张力#RUN#STOP#2#1KHz#3#CHE##END#" + "\n";

            txt_SendMsg.Text = sendmg;
            string sendMsg = this.txt_SendMsg.Text;


            byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendmg);

            byte[] firstBuffer = new byte[buffer.Length + 1];

            firstBuffer[0] = 1; //告诉机器该发送的字节数组为文件

            Buffer.BlockCopy(buffer, 0, firstBuffer, 1, buffer.Length);


            //  if (!string.IsNullOrEmpty(this.lsb_Ips.Text))
            if (!string.IsNullOrEmpty(toolStripComboBox2.Text))
            {

                // string ipendpoint = this.lsb_Ips.Text;

                string ipendpoint = toolStripComboBox2.Text;
                socketDir[ipendpoint].Send(firstBuffer);

                string kk = System.Text.Encoding.UTF8.GetString(firstBuffer);

                ShowMsg("向客户端发送了:" + kk);

            }

            else
            {

                MessageBox.Show("请选择与哪个客户端进行通信");

            }

        }
        #endregion 发送信息
        #region 自动发送文件
        string filePath = null;
        string fileName = null;
        public const int SendBufferSize = 1024 * 1024 * 2;
        System.DateTime filetime = System.DateTime.Now;
        private void ClientSendMsg(string sendMsg, byte symbol)
        {
            byte[] arrClientMsg = Encoding.UTF8.GetBytes(sendMsg);
            byte[] arrClientSendMsg = new byte[arrClientMsg.Length + 1];
            arrClientSendMsg[0] = symbol;
            Buffer.BlockCopy(arrClientMsg, 0, arrClientSendMsg, 1, arrClientMsg.Length);
            //  if (!string.IsNullOrEmpty(textBox51.Text))
            //   {

            string ipendpoint = toolStripComboBox2.Text;
            socketDir[ipendpoint].Send(arrClientSendMsg, 0, arrClientSendMsg.Length, SocketFlags.None);
            //  MessageBox.Show(sendMsg + "指令已开启");

            //  }
            // listtcp[0].GetStream().Write(arrClientSendMsg, 0, arrClientSendMsg.Length);
            toolStripStatusLabel1.Text = "文件已发送";//txtMsg.AppendText("SoFlash:" + GetCurrentTime() + "\r\n" + sendMsg + "\r\n");
        }

        #region 自动获取最新文件
        //自定义一个类
        public class FileTimeInfo
        {
            public string FileName;  //文件名
            public DateTime FileCreateTime;//创建时间
            public string FiletoName;
        }
        public void checknew()
        {
            //使用 GetLatestFileTimeInfo
            //获取d:\test文件中，扩展名为.txt的最新文件
            FileTimeInfo fi = GetLatestFileTimeInfo(@"D:\MPS_Data", ".txt");
            if (fi != null)
            {
                toolStripStatusLabel1.Text = fi.FileName;
            }
            else return;
            filePath = fi.FileName;
            fileName = fi.FiletoName;
            //return fi.FileName;
        }

        //获取最近创建的文件名和创建时间
        //如果没有指定类型的文件，返回null
        static FileTimeInfo GetLatestFileTimeInfo(string dir, string ext)
        {
            List<FileTimeInfo> list = new List<FileTimeInfo>();
            DirectoryInfo d = new DirectoryInfo(dir);
            foreach (FileInfo fi in d.GetFiles())
            {
                if (fi.Extension.ToUpper() == ext.ToUpper())
                {
                    list.Add(new FileTimeInfo()
                    {
                        FileName = fi.FullName,
                        FileCreateTime = fi.CreationTime,
                        FiletoName = fi.Name
                    });
                }
            }
            var qry = from x in list
                      orderby x.FileCreateTime
                      select x;
            return qry.LastOrDefault();
        }


        #endregion 自动获取最新文件

        /// <summary>
        /// 发送文件的方法
        /// </summary>
        /// <param name="fileFullPath">文件全路径(包含文件名称)</param>
        /// 
        private void SendFile(string fileFullPath)
        {
            if (string.IsNullOrEmpty(fileFullPath))
            {
                MessageBox.Show(@"请选择需要发送的文件!");
                return;
            }

            //发送文件之前 将文件名字和长度发送过去
            long fileLength = new FileInfo(fileFullPath).Length;
            string totalMsg = string.Format("{0}&{1}", fileName, fileLength);
            ClientSendMsg(totalMsg, 66);


            //发送文件
            byte[] buffer = new byte[SendBufferSize];

            using (FileStream fs = new FileStream(fileFullPath, FileMode.Open, FileAccess.Read))
            {
                int readLength = 0;
                bool firstRead = true;
                long sentFileLength = 0;
                string ipendpoint = toolStripComboBox2.Text;
                while ((readLength = fs.Read(buffer, 0, buffer.Length)) > 0 && sentFileLength < fileLength)
                {
                    sentFileLength += readLength;
                    //在第一次发送的字节流上加个前缀99
                    if (firstRead)
                    {
                        byte[] firstBuffer = new byte[buffer.Length + 1];
                        firstBuffer[0] = 99; //告诉机器该发送的字节数组为文件

                        Buffer.BlockCopy(buffer, 0, firstBuffer, 1, buffer.Length);

                        socketDir[ipendpoint].Send(firstBuffer, 0, firstBuffer.Length, SocketFlags.None);
                        firstRead = false;
                        continue;
                    }
                    //之后发送的均为直接读取的字节流

                    socketDir[ipendpoint].Send(buffer, 0, readLength, SocketFlags.None);
                }
                fs.Close();
            }
            toolStripStatusLabel1.Text = "SoFlash:" + filetime + "\r\n发送了文件:" + fileName + "\r\n";
        }

        #endregion 自动发送文件

        Dictionary<string, Socket> socketDir = new Dictionary<string, Socket>();

        public void ConnectAccept()
        {

            while (true)//持续监听
            {

                Socket newSoket = sck.Accept();

                socketDir.Add(newSoket.RemoteEndPoint.ToString(), newSoket);

                lsb_Ips.Items.Add(newSoket.RemoteEndPoint.ToString());
                toolStripComboBox1.Items.Add(newSoket.RemoteEndPoint.ToString());
                toolStripComboBox2.Items.Add(newSoket.RemoteEndPoint.ToString());
                // comboBox2.Items.Add(newSoket.RemoteEndPoint.ToString());
                // comboBox3.Items.Add(newSoket.RemoteEndPoint.ToString());

                ShowMsg("客户端链接成功!");


                ParameterizedThreadStart par = new

                 ParameterizedThreadStart(RecevieMsg);

                Thread thread = new Thread(par);


                thread.IsBackground = true;

                thread.Start(newSoket);

            }

        }

        string strSRecMsg = null;
        #region 接受信息
        public void RecevieMsg(object socket)
        {

            Socket newSocket = socket as Socket;
            long fileLength = 0;
            while (true)
            {

                byte[] buffer = new byte[1024 * 1024 * 2];

                int receiveLength = -1;

                try
                {

                    receiveLength = newSocket.Receive(buffer);
                    System.DateTime mesagetime = System.DateTime.Now;
                    string MSGtime = mesagetime.ToString("yyyy/MM/dd/HH:mm:ss");
                    txt_AccMsg.Text = MSGtime + " 接收成功！";
                    #region 接受信息
                    if (buffer[0] == 33)
                    {

                        
                        string str = System.Text.Encoding.UTF8.GetString(buffer, 1, receiveLength - 1);
                        string[] sArray = str.Split('_');
                      

                        textBox1.Text = Convert.ToString(Math.Round(((Convert.ToDouble(sArray[0]))*0.0714)-145.86, 2));

                        textBox2.Text = Convert.ToString(Math.Round(((Convert.ToDouble(sArray[1]))*0.9117)-1863.3, 2));

                        textBox3.Text = Convert.ToString(Math.Round(((Convert.ToDouble(sArray[2]))*0.6861)-1401.03, 2));

                        textBox4.Text = Convert.ToString(Math.Round(((Convert.ToDouble(sArray[3]))*0.6962)-1429.9, 2));

                        textBox5.Text = Convert.ToString(Math.Round(((Convert.ToDouble(sArray[4]))*0.7614)-29.678, 2));

                        textBox6.Text = Convert.ToString(Math.Round(((Convert.ToDouble(sArray[5])) *0.006)-0.1885, 2));

                        textBox7.Text = Convert.ToString(Math.Round((Convert.ToDouble(sArray[6])) / 4096 * 2.5, 2));
                        

                        textBox8.Text = Convert.ToString(Math.Round((Convert.ToDouble(sArray[7])) / 4096 * 2.5, 2));

                        textBox9.Text =  sArray[8];
                        textBox10.Text = sArray[9];
                        textBox11.Text = sArray[10];
                        textBox12.Text = sArray[11];
                        textBox13.Text = sArray[12];
                        textBox14.Text = sArray[13];
                        textBox15.Text = sArray[14];
                        textBox16.Text = sArray[15];
                        textBox17.Text = sArray[16];
                        textBox18.Text = sArray[17];
                        textBox37.Text = sArray[18];
                        textBox38.Text = sArray[19];
                        textBox39.Text = sArray[20];
                       
                        textBox19.Text = sArray[22];  //AD590  1
                        textBox20.Text = sArray[23];  //AD590  2
                        textBox21.Text = sArray[24];  //AD590  3  
                        textBox22.Text = sArray[25];  //AD590  4
                        textBox23.Text = sArray[26];  //AD590  5
                        textBox24.Text = sArray[27];  //AD590  6
                        textBox25.Text = sArray[28];  //AD590  7

                        textBox26.Text = sArray[29];  //热敏电阻 1
                        textBox31.Text = sArray[30];  //热敏电阻 2
                        textBox32.Text = sArray[31];  //热敏电阻 3
                        textBox33.Text = sArray[32];  //热敏电阻 4
                        textBox34.Text = sArray[33];  //热敏电阻 5
                        textBox35.Text = sArray[34];  //热敏电阻 6
                        textBox36.Text = sArray[37];  //热敏电阻 7
                        textBox40.Text = sArray[38];  //热敏电阻 8
                        
                        if (sArray[41] == "open")
                        {
                            pictureBox4.Image = server729.Properties.Resources._02;

                        }
                        else
                        {
                            pictureBox4.Image = server729.Properties.Resources._01;
                            textBox52.Text += MSGtime + "                          430解析出错" + "\t"+" \n";
                            woring("430解析出错");
                            
                        }
                        if (sArray[42] == "open")
                        {
                            pictureBox5.Image = server729.Properties.Resources._02;

                        }
                        else
                        {
                            pictureBox5.Image = server729.Properties.Resources._01;
                            textBox52.Text += MSGtime + "                          32解析出错" + "\t" + " \n";
                            woring("32解析出错");
                            
                        }





                    }
                    #endregion 接受信息
                    #region 接收文件
                    else if (buffer[0] == 66)
                    {

                        string fileNameWithLength = Encoding.UTF8.GetString(buffer, 1, receiveLength - 1);
                        strSRecMsg = fileNameWithLength.Split('&').First(); //文件名
                        fileLength = Convert.ToInt64(fileNameWithLength.Split('&').Last());//文件长度

                    }
                  
                    else if (buffer[0] == 99)
                    {

                        string savePath = "D:\\MPS\\Wave_" + strSRecMsg;


                        //获取文件的全路径
                        //保存文件
                        int received = 0;
                        long receivedTotalFilelength = 0;
                        bool firstWrite = true;
                        using (FileStream fs = new FileStream(savePath, FileMode.Create, FileAccess.Write))
                        {
                            while (receivedTotalFilelength < fileLength) //之后收到的文件字节数组
                            {
                                if (firstWrite)
                                {
                                    fs.Write(buffer, 1, receiveLength - 1); //第一次收到的文件字节数组 需要移除标识符2 后写入文件
                                    fs.Flush();
                                    receivedTotalFilelength += receiveLength - 1;
                                    firstWrite = false;
                                    continue;
                                }
                                received = newSocket.Receive(buffer); //之后每次收到的文件字节数组 可以直接写入文件
                                fs.Write(buffer, 0, received);
                                fs.Flush();

                                receivedTotalFilelength += received;
                            }
                            fs.Close();

                            string fName = savePath.Substring(savePath.LastIndexOf("\\") + 1); //文件名 不带路径
                            string fPath = savePath.Substring(0, savePath.LastIndexOf("\\"));
                            // string strYMD1 = currentTime.ToString("yyyy/MM/dd/HH:mm:ss");
                            toolStripStatusLabel1.Text = "您成功接收了文件" + fName + "\r\n保存路径为:" + fPath + "\r\n";
                        }
                    }
                    #endregion 接收文件
                    #region 指示灯
                    else if (buffer[0] == 88)
                    {
                        if (buffer[1] == 12)
                        {
                            label67.Text = "风扇上电成功 ";
                            pictureBox1.Image = server729.Properties.Resources._02;
                        }
                        if (buffer[1] == 13)
                        {
                            label67.Text = "风扇断电成功 ";
                            pictureBox1.Image = server729.Properties.Resources._01;
                        }
                        if (buffer[1] == 22)
                        {
                            label67.Text = "温控上电成功 ";
                            pictureBox2.Image = server729.Properties.Resources._02;

                        }
                        if (buffer[1] == 23)
                        {
                            label67.Text = "温控断电成功 ";
                            pictureBox2.Image = server729.Properties.Resources._01;
                        }
                        if (buffer[1] == 32)
                        {
                            label67.Text = "波形上电成功 ";
                            pictureBox3.Image = server729.Properties.Resources._02;

                        }
                        if (buffer[1] == 33)
                        {
                            label67.Text = "波形断电成功 ";
                            pictureBox3.Image = server729.Properties.Resources._01;
                        }
                        if (buffer[1] == 41)
                        {
                            label67.Text = "波形定时器启动成功 ";
                        }
                        if (buffer[1] == 42)
                        {
                            label67.Text = "波形发射成功 ";
                        }
                        if (buffer[1] == 43)
                        {
                            label67.Text = "波形硬件使能成功 ";
                        }
                        if (buffer[1] == 44)
                        {

                            label67.Text = "波形软件使能成功 ";
                        }
                        #endregion 指示灯



                    }
                }

                catch (Exception ex)
                {
                    System.DateTime mesagetime1 = System.DateTime.Now;
                    string MSGtime1 = mesagetime1.ToString("yyyy/MM/dd/HH:mm:ss");
                    ShowMsg(ex.Message);
                    textBox52.Text += MSGtime1+"                          " + ex.Message + " \n";
                    woring(ex.Message);

                }

               
            }

        }
        #endregion 接受信息
        #endregion 收发信息
        #region 报错函数
        public void woring(string XX)
        {
            System.DateTime mesagetime2 = System.DateTime.Now;
            string strYMD = mesagetime2.ToString("MMdd HH:mm:ss");
            string strYMD1 = mesagetime2.ToString("MMdd");
            if (!File.Exists("D:\\woring\\woring_" + strYMD1 + ".txt"))
            {
                FileStream bender1 = new FileStream(("D:\\bender\\bender_" + strYMD1 + ".txt"), FileMode.Create, FileAccess.Write);
                StreamWriter ben1 = new StreamWriter(bender1);
                ben1.WriteLine("时间--" + "\t" + "报错" + "\t");
                ben1.Close();
                bender1.Close();

            }
            else
            {
                FileStream bender1 = new FileStream(("D:\\woring\\woring_" + strYMD1 + ".txt"), FileMode.Append, FileAccess.Write);
                StreamWriter ben1 = new StreamWriter(bender1);
                ben1.WriteLine(strYMD + "\t" + XX + "\t");
                ben1.Close();
                bender1.Close();
            }
        
        }
        #endregion 报错函数
        #region 命令台
        //private void button7_Click(object sender, EventArgs e)
        //{
        //            string sendMsg = "0x115";

        //    byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendMsg);
        //    if (button7.Text == "100Hz采集")
        //    {
        //        button7.Text = "关闭100Hz采集";
        //    }
        //    else
        //    {
        //        button7.Text = "100Hz采集";
        //    }
        //    if (!string.IsNullOrEmpty(textBox50.Text))
        //    {

        //        string ipendpoint = textBox50.Text;

        //        socketDir[ipendpoint].Send(buffer);
        //        MessageBox.Show(sendMsg + "指令已开启");

        //    }

        //    else
        //    {

        //        MessageBox.Show("请确认连接/重新选择指令");

        //    }
        //}

        //private void button11_Click(object sender, EventArgs e)
        //{
        //    string sendMsg = "0x116";

        //    byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendMsg);
        //    if (button11.Text == "1KHz采集")
        //    {
        //        button11.Text = "关闭1KHz采集";
        //    }
        //    else
        //    {
        //        button11.Text = "1KHz采集";
        //    }
        //    if (!string.IsNullOrEmpty(toolStripComboBox1.Text))
        //    {

        //        string ipendpoint = toolStripComboBox1.Text;

        //        socketDir[ipendpoint].Send(buffer);
        //        MessageBox.Show(sendMsg + "指令已开启");

        //    }

        //    else
        //    {

        //        MessageBox.Show("请确认连接/重新选择指令");

        //    }
        //}

        //private void button6_Click_1(object sender, EventArgs e)
        //{
        //    string sendMsg = "0x117";

        //    byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendMsg);
        //    if (button6.Text == "2KHz采集")
        //    {
        //        button6.Text = "关闭2KHz采集";
        //    }
        //    else
        //    {
        //        button6.Text = "2KHz采集";
        //    }
        //    if (!string.IsNullOrEmpty(textBox50.Text))
        //    {

        //        string ipendpoint = textBox50.Text;

        //        socketDir[ipendpoint].Send(buffer);
        //        MessageBox.Show(sendMsg + "指令已开启");

        //    }

        //    else
        //    {

        //        MessageBox.Show("请确认连接/重新选择指令");

        //    }
        //}

        //private void button10_Click(object sender, EventArgs e)
        //{
        //    string sendMsg = "0x118";

        //    byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendMsg);
        //    if (button10.Text == "5KHz采集")
        //    {
        //        button10.Text = "关闭5KHz采集";
        //    }
        //    else
        //    {
        //        button10.Text = "5KHz采集";
        //    }
        //    if (!string.IsNullOrEmpty(textBox50.Text))
        //    {

        //        string ipendpoint = textBox50.Text;

        //        socketDir[ipendpoint].Send(buffer);
        //        MessageBox.Show(sendMsg + "指令已开启");

        //    }

        //    else
        //    {

        //        MessageBox.Show("请确认连接/重新选择指令");

        //    }
        //}

        private void button9_Click(object sender, EventArgs e)
        {
            string sendMsg = "0x119";

            byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendMsg);

            if (!string.IsNullOrEmpty(toolStripComboBox1.Text))
            {

                string ipendpoint = toolStripComboBox1.Text;

                socketDir[ipendpoint].Send(buffer);
                MessageBox.Show(sendMsg + "指令已开启");

            }

            else
            {

                MessageBox.Show("请确认连接/重新选择指令");

            }
        }


        private void button8_Click(object sender, EventArgs e)
        {
            string sendMsg = "0x121";

            byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendMsg);

            if (!string.IsNullOrEmpty(toolStripComboBox1.Text))
            {

                string ipendpoint = toolStripComboBox1.Text;

                socketDir[ipendpoint].Send(buffer);
                MessageBox.Show(sendMsg + "指令已开启");

            }

            else
            {

                MessageBox.Show("请确认连接/重新选择指令");

            }
        }

        private void button12_Click(object sender, EventArgs e)
        {
            string sendMsg = "0x122";

            byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendMsg);

            if (!string.IsNullOrEmpty(toolStripComboBox1.Text))
            {

                string ipendpoint = toolStripComboBox1.Text;

                socketDir[ipendpoint].Send(buffer);
                MessageBox.Show(sendMsg + "指令已开启");

            }

            else
            {

                MessageBox.Show("请确认连接/重新选择指令");

            }
        }

        //private void button15_Click(object sender, EventArgs e)
        //{
        //    string sendMsg = "0x123";

        //    byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendMsg);

        //    if (!string.IsNullOrEmpty(toolStripComboBox1.Text))
        //    {

        //        string ipendpoint = toolStripComboBox1.Text;  // 风扇上电

        //        socketDir[ipendpoint].Send(buffer);
        //        MessageBox.Show(sendMsg + "指令已开启");

        //    }

        //    else
        //    {

        //        MessageBox.Show("请确认连接/重新选择指令");

        //    }
        //}

        //private void button17_Click(object sender, EventArgs e)
        //{
        //    string sendMsg = "0x124";

        //    byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendMsg);

        //    if (!string.IsNullOrEmpty(toolStripComboBox1.Text))
        //    {

        //        string ipendpoint = toolStripComboBox1.Text;    // 风扇断电

        //        socketDir[ipendpoint].Send(buffer);
        //        MessageBox.Show(sendMsg + "指令已开启");

        //    }

        //    else
        //    {

        //        MessageBox.Show("请确认连接/重新选择指令");

        //    }
        //}

        //private void button14_Click(object sender, EventArgs e)
        //{
        //    string sendMsg = "0x125";

        //    byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendMsg);

        //    if (!string.IsNullOrEmpty(toolStripComboBox1.Text))
        //    {

        //        string ipendpoint = toolStripComboBox1.Text;     //温控上电

        //        socketDir[ipendpoint].Send(buffer);
        //        MessageBox.Show(sendMsg + "指令已开启");

        //    }

        //    else
        //    {

        //        MessageBox.Show("请确认连接/重新选择指令");

        //    }
        //}

        //private void button16_Click(object sender, EventArgs e)
        //{
        //    string sendMsg = "0x126";

        //    byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendMsg);

        //    if (!string.IsNullOrEmpty(toolStripComboBox1.Text))
        //    {

        //        string ipendpoint = toolStripComboBox1.Text;

        //        socketDir[ipendpoint].Send(buffer);
        //        MessageBox.Show(sendMsg + "指令已开启");  //  温控断电

        //    }

        //    else
        //    {

        //        MessageBox.Show("请确认连接/重新选择指令");

        //    }
        //}

        //private void button19_Click(object sender, EventArgs e)
        //{
        //    string sendMsg = "0x127";

        //    byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendMsg);

        //    if (!string.IsNullOrEmpty(toolStripComboBox1.Text))
        //    {

        //        string ipendpoint = toolStripComboBox1.Text;

        //        socketDir[ipendpoint].Send(buffer);
        //        MessageBox.Show(sendMsg + "指令已开启");  //  波形上电

        //    }

        //    else
        //    {

        //        MessageBox.Show("请确认连接/重新选择指令");

        //    }
        //}

        //private void button18_Click(object sender, EventArgs e)
        //{
        //    string sendMsg = "0x128";

        //    byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendMsg);

        //    if (!string.IsNullOrEmpty(toolStripComboBox1.Text))
        //    {

        //        string ipendpoint = toolStripComboBox1.Text;

        //        socketDir[ipendpoint].Send(buffer);
        //        MessageBox.Show(sendMsg + "指令已开启");  //  波形断电

        //    }

        //    else
        //    {

        //        MessageBox.Show("请确认连接/重新选择指令");

        //    }
        //}
        #endregion 命令台
        #region 定时器
        void timertemp1_Elapsed(object send, System.Timers.ElapsedEventArgs e) //扫描文件
        {
            checknew();

        }
        void timertemp2_Elapsed(object send, System.Timers.ElapsedEventArgs e)  //发送文件
        {
            SendFile(filePath);

        }
        void timertemp3_Elapsed(object send, System.Timers.ElapsedEventArgs e)  //发送数据
        {
            Sendmesg();

        }
        void timertemp4_Elapsed(object send, System.Timers.ElapsedEventArgs e)  //电源超时
        {
            label91.ForeColor = Color.Red;
            label91.Text="连接超时，请检查通信线路！";
            //spPower.Close();
        }
        void timertemp5_Elapsed(object send, System.Timers.ElapsedEventArgs e)
        {
            System.DateTime sysTime = System.DateTime.Now;
            TimeSpan ts = mywatch.Elapsed;
            toolStripStatusLabel3.Text = sysTime.ToString("yyyy年MM月dd日 HH:mm:ss");
            toolStripStatusLabel2.Text = "系统已运行："+ts.Days + "天" + ts.Hours + "时" + ts.Minutes + "分" + ts.Seconds + "秒";

        } //系统时间
        void timertemp6_Elapsed(object send, System.Timers.ElapsedEventArgs e)  //发送数据
        {
            if (spPower.IsOpen)
            {

                textBox27.Text = "";
                fx[0] = 0x7e;
                fx[1] = Convert.ToByte((2 / 16) + 0x30);
                fx[2] = Convert.ToByte((2 % 16) + 0x30);
                fx[3] = Convert.ToByte((2 / 16) + 0x30);
                fx[4] = Convert.ToByte((2 % 16) + 0x30);
                fx[5] = CID1_h;
                fx[6] = CID1_l;

                fx[7] = dispall_h;
                fx[8] = dispall_l;

                fx[9] = 0x30;
                fx[10] = 0x30;
                fx[11] = 0x30;
                fx[12] = 0x30;
                int c;

                for (c = 1; c < 13; c++)
                {
                    he += fx[c];
                }
                chekN(he);
                fx[13] = chksum[0];
                fx[14] = chksum[1];
                fx[15] = chksum[2];
                fx[16] = chksum[3];
                fx[17] = 0x0d;
                for (c = 0; c < 18; c++)
                {
                    textBox27.Text += " " + fx[c].ToString("x");
                }
                he = 0;
                spPower.Write(fx, 0, 18);
            }
            else
            {
                label91.ForeColor = Color.Red;
                label91.Text = "串口未打开！"; }

        }
       
        #endregion 定时器
        #region 界面载入
        private void Form1_Load(object sender, EventArgs e)
        {
            wavecongif();
            timertemp1 = new System.Timers.Timer(3000);
            timertemp1.AutoReset = true;
            timertemp1.Elapsed += new System.Timers.ElapsedEventHandler(timertemp1_Elapsed);
            timertemp2 = new System.Timers.Timer(4000);
            timertemp2.AutoReset = true;
            timertemp2.Elapsed += new System.Timers.ElapsedEventHandler(timertemp2_Elapsed);
            timertemp3 = new System.Timers.Timer(3000);
            timertemp3.AutoReset = true;
            timertemp3.Elapsed += new System.Timers.ElapsedEventHandler(timertemp3_Elapsed);
            timertemp4 = new System.Timers.Timer(2000);
            timertemp4.AutoReset = false;
            timertemp4.Elapsed += new System.Timers.ElapsedEventHandler(timertemp4_Elapsed);
            timertemp5 = new System.Timers.Timer(1000);
            timertemp5.AutoReset = true;
            timertemp5.Elapsed+=new System.Timers.ElapsedEventHandler(timertemp5_Elapsed);
            timertemp6 = new System.Timers.Timer(3000);
            timertemp6.AutoReset = true;
            timertemp6.Elapsed  += new System.Timers.ElapsedEventHandler(timertemp6_Elapsed);
          
            port_powerinit();
            port_spbenderint();
            timertemp5.Start();
           
            string[] portNs = SerialPort.GetPortNames();
            
            foreach (string portN in portNs)
            {
                comboBox2.Items.Add(portN);
                comboBox3.Items.Add(portN);
            }

            this.zedGraphControl1.GraphPane.Title.Text = "温度折线图";
            this.zedGraphControl1.GraphPane.XAxis.Title.Text = "时间";
            this.zedGraphControl1.GraphPane.YAxis.Title.Text = "摄氏度";
            this.zedGraphControl1.GraphPane.XAxis.Type = ZedGraph.AxisType.DateAsOrdinal;
            this.zedGraphControl1.GraphPane.XAxis.Scale.Format = "HH:mm:ss";

            for (int i = 0; i <= 100; i++)
            {
                double x = (double)new XDate(DateTime.Now.AddSeconds(-(100 - i)));
                double y = 0;
                list.Add(x, y);
            }
            DateTime dt = DateTime.Now;

            myCurve = zedGraphControl1.GraphPane.AddCurve("My Curve",
                    list, Color.LimeGreen, SymbolType.None);

            this.zedGraphControl1.AxisChange();
            this.zedGraphControl1.Refresh();

/////////////////////////////////////////////////////////////////////////
            this.zedGraphControl2.GraphPane.Title.Text = "阻值折线图";
            this.zedGraphControl2.GraphPane.XAxis.Title.Text = "时间";
            this.zedGraphControl2.GraphPane.YAxis.Title.Text = "千欧";
            this.zedGraphControl2.GraphPane.XAxis.Type = ZedGraph.AxisType.DateAsOrdinal;
            this.zedGraphControl2.GraphPane.XAxis.Scale.Format = "HH:mm:ss";

            for (int i = 0; i <= 100; i++)
            {
                double x = (double)new XDate(DateTime.Now.AddSeconds(-(100 - i)));
                double y = 0;
                list1.Add(x, y);
            }
            DateTime dt1 = DateTime.Now;

            myCurve = zedGraphControl2.GraphPane.AddCurve("绝缘阻值",
                    list1, Color.LimeGreen, SymbolType.None);
           zedGraphControl2.GraphPane.Chart.Fill = new Fill(Color.Black);
            this.zedGraphControl2.AxisChange();
            this.zedGraphControl2.Refresh();
           

        }
        #endregion 界面载入
        public static string byteToHexStr(byte[] bytes)
        {
            
            string returnStr = "";
            if (bytes != null)
            {
                for (int i = 0; i < bytes.Length; i++)
                {
                    returnStr += bytes[i].ToString("X2") + " ";
                }
            }
            return returnStr;
        }
        #region 发送波形
        private void button27_Click(object sender, EventArgs e)
        {
            if (comboBox1.Text == "0.01Hz")
            {
                string sendMsg = "0x120";

                byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendMsg);

                if (!string.IsNullOrEmpty(toolStripComboBox1.Text))
                {

                    string ipendpoint = toolStripComboBox1.Text;

                    socketDir[ipendpoint].Send(buffer);
                    MessageBox.Show(sendMsg + "指令已开启");

                }

                else
                {

                    MessageBox.Show("请确认连接/重新选择指令");

                }

            }

            else if (comboBox1.Text == "0.1Hz")
            {

                string sendMsg = "0x129";

                byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendMsg);

                if (!string.IsNullOrEmpty(toolStripComboBox1.Text))
                {

                    string ipendpoint = toolStripComboBox1.Text;

                    socketDir[ipendpoint].Send(buffer);
                    MessageBox.Show(sendMsg + "指令已开启");  //  波形上电

                }

                else
                {

                    MessageBox.Show("请确认连接/重新选择指令");

                }

            }
            else if (comboBox1.Text == "0.25Hz")
            {

                string sendMsg = "0x130";

                byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendMsg);

                if (!string.IsNullOrEmpty(toolStripComboBox1.Text))
                {

                    string ipendpoint = toolStripComboBox1.Text;

                    socketDir[ipendpoint].Send(buffer);
                    MessageBox.Show(sendMsg + "指令已开启");  //  波形上电

                }

                else
                {

                    MessageBox.Show("请确认连接/重新选择指令");

                }

            }
            else if (comboBox1.Text == "1Hz")
            {

                string sendMsg = "0x131";

                byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendMsg);

                if (!string.IsNullOrEmpty(toolStripComboBox1.Text))
                {

                    string ipendpoint = toolStripComboBox1.Text;

                    socketDir[ipendpoint].Send(buffer);
                    MessageBox.Show(sendMsg + "指令已开启");  //  波形上电

                }

                else
                {

                    MessageBox.Show("请确认连接/重新选择指令");

                }

            }
            else if (comboBox1.Text == "5Hz")
            {

                string sendMsg = "0x132";

                byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendMsg);

                if (!string.IsNullOrEmpty(toolStripComboBox1.Text))
                {

                    string ipendpoint = toolStripComboBox1.Text;

                    socketDir[ipendpoint].Send(buffer);
                    MessageBox.Show(sendMsg + "指令已开启");  //  波形上电

                }

                else
                {

                    MessageBox.Show("请确认连接/重新选择指令");

                }

            }
            else if (comboBox1.Text == "10Hz")
            {

                string sendMsg = "0x133";

                byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendMsg);

                if (!string.IsNullOrEmpty(toolStripComboBox1.Text))
                {

                    string ipendpoint = toolStripComboBox1.Text;

                    socketDir[ipendpoint].Send(buffer);
                    MessageBox.Show(sendMsg + "指令已开启");  //  波形上电

                }

                else
                {

                    MessageBox.Show("请确认连接/重新选择指令");

                }

            }
            else if (comboBox1.Text == "50Hz")
            {

                string sendMsg = "0x134";

                byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendMsg);

                if (!string.IsNullOrEmpty(toolStripComboBox1.Text))
                {

                    string ipendpoint = toolStripComboBox1.Text;

                    socketDir[ipendpoint].Send(buffer);
                    MessageBox.Show(sendMsg + "指令已开启");  //  波形上电

                }

                else
                {

                    MessageBox.Show("请确认连接/重新选择指令");

                }

            }
            else if (comboBox1.Text == "100Hz")
            {

                string sendMsg = "0x135";

                byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendMsg);

                if (!string.IsNullOrEmpty(toolStripComboBox1.Text))
                {

                    string ipendpoint = toolStripComboBox1.Text;

                    socketDir[ipendpoint].Send(buffer);
                    MessageBox.Show(sendMsg + "指令已开启");  //  波形上电

                }

                else
                {

                    MessageBox.Show("请确认连接/重新选择指令");

                }

            }



        }
        #endregion 发送波形
        #region 发送信息
        private void Sendmesg()
        {



            string strYMD = currentTime.ToString("yyyy/MM/dd/HH:mm:ss");
            string sendmg = "#" + strYMD + "#" + textBox2.Text + "#" + textBox1.Text + "#" + textBox5.Text + "#" +
                textBox6.Text + "#" + comboBox1.Text + "#" + textBox44.Text + "#" + textBox43.Text + "#" + "33" + "#"
                + "20" + "#" + "26" + "#" + "1111" + "#" + "8888" + "#" + "37" + "#" +
                "0.02" + "#" + "340" + "#" + textBox16.Text + "#" + textBox17.Text + "#" + textBox18.Text + "#" +
                textBox37.Text + "#" + textBox38.Text + "#" + textBox39.Text + "#" +
                "100#3.4#25#RUN#STOP#2#1KHz#3#CHE##END#" + "\n";

            txt_SendMsg.Text = sendmg;
            string sendMsg = this.txt_SendMsg.Text;

            byte[] firstBuffer = new byte[sendmg.Length + 1];


            firstBuffer[0] = 1; //告诉机器该发送的字节数组为参数

            byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendMsg);

            Buffer.BlockCopy(buffer, 0, firstBuffer, 1, sendmg.Length);





            //  if (!string.IsNullOrEmpty(this.lsb_Ips.Text))
            if (!string.IsNullOrEmpty(toolStripComboBox1.Text))
            {

                // string ipendpoint = this.lsb_Ips.Text;

                string ipendpoint = toolStripComboBox1.Text;
                socketDir[ipendpoint].Send(buffer);



                ShowMsg("向客户端发送了:" + sendMsg);

            }

            else
            {

                MessageBox.Show("请选择与哪个客户端进行通信");

            }


        }
        #endregion 发送信息
        #region 菜单控制

        private void button5_Click(object sender, EventArgs e)
        {
            string sendMsg = "0x115";

            byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendMsg);

            if (!string.IsNullOrEmpty(toolStripComboBox1.Text))
            {

                string ipendpoint = toolStripComboBox1.Text;

                socketDir[ipendpoint].Send(buffer);
                MessageBox.Show(sendMsg + "指令已开启");

            }

            else
            {

                MessageBox.Show("请确认连接/重新选择指令");

            }

        }

        
        private void button6_Click_1(object sender, EventArgs e)
        {
            string sendMsg = "0x117";

            byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendMsg);

            if (!string.IsNullOrEmpty(toolStripComboBox1.Text))
            {

                string ipendpoint = toolStripComboBox1.Text;

                socketDir[ipendpoint].Send(buffer);
                MessageBox.Show(sendMsg + "指令已开启");

            }

            else
            {

                MessageBox.Show("请确认连接/重新选择指令");

            }
        }

        private void 开启监听ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            try
            {
                string IP = "192.168.77.10";
                string Point = "666";
                sck = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);

                IPAddress ip = IPAddress.Parse(IP);

                IPEndPoint endpoint = new IPEndPoint(ip, Convert.ToInt32(Point));

                sck.Bind(endpoint);

                sck.Listen(10);

                ShowMsg("开启监听！");

                Thread thread = new Thread(ConnectAccept);

                thread.IsBackground = true;

                thread.Start();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void 上电ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string sendMsg = "0x123";

            byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendMsg);

            if (!string.IsNullOrEmpty(toolStripComboBox1.Text))
            {

                string ipendpoint = toolStripComboBox1.Text;  // 风扇上电

                socketDir[ipendpoint].Send(buffer);
                MessageBox.Show(sendMsg + "指令已开启");

            }

            else
            {

                MessageBox.Show("请确认连接/重新选择指令");

            }
        }

        private void 断电ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string sendMsg = "0x124";

            byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendMsg);

            if (!string.IsNullOrEmpty(toolStripComboBox1.Text))
            {

                string ipendpoint = toolStripComboBox1.Text;    // 风扇断电

                socketDir[ipendpoint].Send(buffer);
                MessageBox.Show(sendMsg + "指令已开启");

            }

            else
            {

                MessageBox.Show("请确认连接/重新选择指令");

            }
        }

        private void 上电ToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            string sendMsg = "0x125";

            byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendMsg);

            if (!string.IsNullOrEmpty(toolStripComboBox1.Text))
            {

                string ipendpoint = toolStripComboBox1.Text;     //温控上电

                socketDir[ipendpoint].Send(buffer);
                MessageBox.Show(sendMsg + "指令已开启");

            }

            else
            {

                MessageBox.Show("请确认连接/重新选择指令");

            }
        }

        private void 断电ToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            string sendMsg = "0x126";

            byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendMsg);

            if (!string.IsNullOrEmpty(toolStripComboBox1.Text))
            {

                string ipendpoint = toolStripComboBox1.Text;

                socketDir[ipendpoint].Send(buffer);
                MessageBox.Show(sendMsg + "指令已开启");  //  温控断电

            }

            else
            {

                MessageBox.Show("请确认连接/重新选择指令");

            }
        }

        private void 上电ToolStripMenuItem2_Click(object sender, EventArgs e)
        {
            string sendMsg = "0x127";

            byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendMsg);

            if (!string.IsNullOrEmpty(toolStripComboBox1.Text))
            {

                string ipendpoint = toolStripComboBox1.Text;

                socketDir[ipendpoint].Send(buffer);
                MessageBox.Show(sendMsg + "指令已开启");  //  波形上电

            }

            else
            {

                MessageBox.Show("请确认连接/重新选择指令");

            }
        }

        private void 断电ToolStripMenuItem2_Click(object sender, EventArgs e)
        {
            string sendMsg = "0x128";

            byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendMsg);

            if (!string.IsNullOrEmpty(toolStripComboBox1.Text))
            {

                string ipendpoint = toolStripComboBox1.Text;

                socketDir[ipendpoint].Send(buffer);
                MessageBox.Show(sendMsg + "指令已开启");  //  波形断电

            }

            else
            {

                MessageBox.Show("请确认连接/重新选择指令");

            }
        }

        private void 开启通信ToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            timertemp1.Start();
            timertemp2.Start();
            timertemp3.Start();
        }

        private void 关闭通信ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            timertemp3.Close();
            timertemp2.Close();
            timertemp1.Close();


        }

        private void 开启数据采集ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string sendMsg = "0x116";

            byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendMsg);

            if (!string.IsNullOrEmpty(toolStripComboBox1.Text))
            {

                string ipendpoint = toolStripComboBox1.Text;

                socketDir[ipendpoint].Send(buffer);
                MessageBox.Show(sendMsg + "指令已开启");

            }

            else
            {

                MessageBox.Show("请确认连接/重新选择指令");

            }

        }

        private void 开启通信ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string sendMsg = "0x111";

            byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendMsg);

            // if (!string.IsNullOrEmpty(this.lsb_Ips.Text))
            if (!string.IsNullOrEmpty(toolStripComboBox1.Text))
            {

                string ipendpoint = toolStripComboBox1.Text;

                socketDir[ipendpoint].Send(buffer);
                MessageBox.Show(sendMsg + "指令已开启");

            }

            else
            {

                MessageBox.Show("请确认连接/重新选择指令");

            }

        }

        private void toolStripMenuItem2_Click(object sender, EventArgs e)
        {
            string sendMsg = "0x112";
            pictureBox4.Image = server729.Properties.Resources._01;
            pictureBox5.Image = server729.Properties.Resources._01;

            byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendMsg);

            if (!string.IsNullOrEmpty(toolStripComboBox1.Text))
            {

                string ipendpoint = toolStripComboBox1.Text;

                socketDir[ipendpoint].Send(buffer);
                MessageBox.Show(sendMsg + "指令已开启");

            }

            else
            {

                MessageBox.Show("请确认连接/重新选择指令");

            }

        }

        private void toolStripMenuItem3_Click(object sender, EventArgs e)
        {
            string sendMsg = "0x118";


            byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendMsg);

            if (!string.IsNullOrEmpty(toolStripComboBox1.Text))
            {

                string ipendpoint = toolStripComboBox1.Text;

                socketDir[ipendpoint].Send(buffer);
                MessageBox.Show(sendMsg + "指令已开启");

            }

            else
            {

                MessageBox.Show("请确认连接/重新选择指令");

            }
        }

        private void 开启文件接受ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string sendMsg = "0x136";


            byte[] buffer = System.Text.Encoding.UTF8.GetBytes(sendMsg);

            if (!string.IsNullOrEmpty(toolStripComboBox1.Text))
            {

                string ipendpoint = toolStripComboBox1.Text;

                socketDir[ipendpoint].Send(buffer);
                MessageBox.Show(sendMsg + "指令已开启");

            }

            else
            {

                MessageBox.Show("请确认连接/重新选择指令");

            }
        }

        private void 程控电源ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            panel1.Show();
        }


        #endregion 菜单控制
        #region 程控电源
        #region 串口配置
        public SerialPort spPower = new SerialPort();
        public string status2;
        public string[] d = new string[22];
       // private StringBuilder builder = new StringBuilder();//避免在事件处理方法中反复的创建，定义到外面。

        public void port_powerinit()
        {

            spPower.DataReceived += new SerialDataReceivedEventHandler(spPower_DataReceived);

        }
        public void startPower()
        {
            if (!spPower.IsOpen)
            {
                string portname = comboBox2.Text; int baudrate = 9600; int databits = 8; Parity parity = Parity.None; StopBits stopbits = StopBits.One;
                spPower.PortName = portname;
                spPower.BaudRate = baudrate;
                spPower.DataBits = databits;
                spPower.Parity = parity;
                spPower.StopBits = stopbits;
                spPower.DtrEnable = true;//若不定义 串口监听不能使
                spPower.RtsEnable = true;//若不定义 串口监听不能使
                //spPower.ReadTimeout = 1000;
                try
                {
                    spPower.Open();
                    toolStripStatusLabel1.Text = "串口启动成功";
                }
                catch (Exception error)
                {
                    MessageBox.Show(error.Message);
                }

            }
        }
        #endregion 串口配置
        #region 数据解析
        private void spPower_DataReceived(object sender, SerialDataReceivedEventArgs e)
        {
            System.DateTime nowT = System.DateTime.Now;
            string sb = nowT.ToString("HH:mm:ss");
            timertemp4.Close();
            Thread.Sleep(500);
            int n = spPower.BytesToRead;
            byte[] S = new byte[n];
            spPower.Read(S,0,n);
            for (int i = 1; i < n - 5; i++)
            {

                She += S[i];
            }
            chekN(She);
            if ((S[n - 5] == chksum[0]) & (S[n - 4] == chksum[1]) & (S[n - 3] == chksum[2]) & (S[n - 2] == chksum[3]))
            {
                
                comboBox2.Enabled = false;
                button7.Enabled = true;
                button10.Enabled = true;
                button11.Enabled = true;
                button4.Enabled = true;
                button2.Enabled = true;
                button14.Enabled = true;
                button3.Enabled = true;
                button1.Text = "断开设备";
                textBox28.Text = "";
                toolStripStatusLabel1.Text = "设备通信状态：通信正常！";
                for (int c = 0; c < n; c++)
                {
                    textBox28.Text += " " + S[c].ToString("x");
                }
                She = 0;
                for (int i = 0; i < n; i++)
                {
                    SS[i] = S[i];

                }
                #region 状态判断
                if ((SS[13] == 0x30) & (SS[14] == 0x30))
                { label91.Text = "待机状态"; }
                else if ((SS[13] == 0x30) & (SS[14] == 0x31))
                { label91.Text = "运行状态"; }
                else if ((SS[13] == 0x30) & (SS[14] == 0x32))
                { label91.Text = "设置状态"; }
                else if ((SS[13] == 0x30) & (SS[14] == 0x33))
                { label91.Text = "调试状态"; }
                else if ((SS[13] == 0x30) & (SS[14] == 0x35))
                {
                    label91.ForeColor = Color.Red;
                    label91.Text = "短路报警";
                }
                else if ((SS[13] == 0x30) & (SS[14] == 0x36))
                {
                    label91.ForeColor = Color.Red;
                    label91.Text = "过热报警";
                   
                }
                else if ((SS[13] == 0x30) & (SS[14] == 0x37))
                {
                    label91.ForeColor = Color.Red;
                    label91.Text = "过载报警";
                }
                else if ((SS[13] == 0x30) & (SS[14] == 0x38))
                {
                    label91.ForeColor = Color.Red;
                    label91.Text = "超电压上限报警";
                }
                else if ((SS[13] == 0x30) & (SS[14] == 0x39))
                {
                    label91.ForeColor = Color.Red;
                    label91.Text = "超电流上限报警";
                }
                else if ((SS[13] == 0x30) & (SS[14] == 0x41))
                {
                    label91.ForeColor = Color.Red;
                    label91.Text = "散热器缺水报警";
                }
                else if ((SS[13] == 0x30) & (SS[14] == 0x42))
                {
                    label91.ForeColor = Color.Red;
                    label91.Text = "输入过压报警";
                }
                else if ((SS[13] == 0x30) & (SS[14] == 0x43))
                {
                    label91.ForeColor = Color.Red;
                    label91.Text = "输入欠压报警";
                }
                if ((SS[7] == 0x30) & (SS[8] >= 0x30) & (SS[8] <= 0x39))
                {
                       
                         if (SS[8] == 0x30) 
                         {
                             label91.ForeColor = Color.LimeGreen;
                             label91.Text= sb+":"+"执行成功！"; 
                         }
                         else if (SS[8] == 0x36) 
                         {
                             label91.ForeColor = Color.Red;
                             label91.Text = sb + ":" + "执行成功，无效数据，超出范围！";
                         }
                    else if (SS[8] == 0x37)
                      {
                          label91.ForeColor = Color.Red;
                          label91.Text= sb+":"+"执行成功，电源不在可设置状态！";
                       }

                }
                else
                {
                    label91.ForeColor = Color.Red;
                    label91.Text= sb+":"+"执行不成功！";
                    spPower.DiscardInBuffer();
                 
                }
                #endregion 状态判断
                
                #region 数值确认
                label6.Text = (SS[13] - 0x30) * 100 + (SS[14] - 0x30) * 10 + (SS[15] - 0x30) + "." + (SS[16] - 0x30);
                label17.Text = (SS[17] - 0x30) * 1000 + (SS[18] - 0x30) * 100 + (SS[19] - 0x30) * 10 + (SS[20] - 0x30) + ".0";
                label16.Text = (SS[21] - 0x30) * 100 + (SS[22] - 0x30) * 10 + (SS[23] - 0x30) + "." + (SS[24] - 0x30);
                label12.Text = (SS[25] - 0x30) * 100 + (SS[26] - 0x30) * 10 + (SS[27] - 0x30) + "." + (SS[28] - 0x30);
                label15.Text = (SS[30] - 0x30) + "." + (SS[31] - 0x30) + "" + (SS[32] - 0x30);
                #endregion 数值确认
              

            }
            else 
            {
                label91.ForeColor = Color.Red;
                label91.Text = sb + ":" + "设备通信状态：校验错误！";
                toolStripStatusLabel1.Text = "设备通信状态：校验错误！";
                spPower.DiscardInBuffer();
               
            }
            if (Vs == 1)
            {
                textBox27.Text = "";
                fx[0] = 0x7e;
                fx[1] = Convert.ToByte((2 / 16) + 0x30);
                fx[2] = Convert.ToByte((2 % 16) + 0x30);
                fx[3] = Convert.ToByte((2 / 16) + 0x30);
                fx[4] = Convert.ToByte((2 % 16) + 0x30);
                fx[5] = CID1_h;
                fx[6] = CID1_l;

                fx[7] = dispall_h;
                fx[8] = dispall_l;

                fx[9] = 0x30;
                fx[10] = 0x30;
                fx[11] = 0x30;
                fx[12] = 0x30;
                int c;

                for (c = 1; c < 13; c++)
                {
                    he += fx[c];
                }
                chekN(he);
                fx[13] = chksum[0];
                fx[14] = chksum[1];
                fx[15] = chksum[2];
                fx[16] = chksum[3];
                fx[17] = 0x0d;
                for (c = 0; c < 18; c++)
                {
                    textBox27.Text += " " + fx[c].ToString("x");
                }
                he = 0;
                spPower.Write(fx, 0, 18);
                Vs = 0;
            }
            spPower.DiscardInBuffer();
          

        }
        #endregion 数据解析
        #region 校验函数
        private void chekN(long K)
        {
            int i;
            long S;
            long[] che = new long[4];
            S = 65536 - K;
            che[0] = S / 4096;
            che[1] = (S % 4096) / 256;
            che[2] = ((S % 4096) % 256) / 16;
            che[3] = ((S % 4096) % 256) % 16;
            for (i = 0; i < 4; i++)
            {
                if ((che[i] >= 0) & (che[i] <= 9))
                {
                    chksum[i] = Convert.ToByte(che[i] + 0x30);

                }
                else if ((che[i] >= 10) & (che[i] <= 15))
                {
                    chksum[i] = Convert.ToByte(che[i] + 0x37);

                }
            }


        }
        #endregion 校验函数
        #region 按键设置
        private void button1_Click(object sender, EventArgs e)  //连接设备
        {
            
            startPower();
            
            if (button1.Text == "断开设备")
            {
                button1.Text = "连接设备";
               
                spPower.Close();
                comboBox2.Enabled = true;
                toolStripStatusLabel1.Text = "通信状态：断开连接！";
                button7.Enabled = false;
                button10.Enabled = false;
                button11.Enabled = false;
                button4.Enabled = false;
                button2.Enabled = false;
                button14.Enabled = false;
                button3.Enabled = false;
            }
            if (spPower.IsOpen & (button1.Text == "连接设备"))
            {
                timertemp4.Start();
                textBox27.Text = "";
                fx[0] = 0x7e;
                fx[1] = Convert.ToByte((2 / 16) + 0x30);
                fx[2] = Convert.ToByte((2 % 16) + 0x30);
                fx[3] = Convert.ToByte((2 / 16) + 0x30);
                fx[4] = Convert.ToByte((2 % 16) + 0x30);
                fx[5] = CID1_h;
                fx[6] = CID1_l;

                fx[7] = state_h;
                fx[8] = state_l;

                fx[9] = 0x30;
                fx[10] = 0x30;
                fx[11] = 0x30;
                fx[12] = 0x30;
                int c;

                for (c = 1; c < 13; c++)
                {
                    he += fx[c];
                }
                chekN(he);
                fx[13] = chksum[0];
                fx[14] = chksum[1];
                fx[15] = chksum[2];
                fx[16] = chksum[3];
                fx[17] = 0x0d;
                for (c = 0; c < 18; c++)
                {
                    textBox27.Text += " " + fx[c].ToString("x");
                }
                he = 0;
                spPower.Write(fx, 0, 18);



            }
            else
            {
                label91.ForeColor = Color.Red;
                label91.Text = "串口未打开！"; }

        }

        private void button2_Click(object sender, EventArgs e)  //启动按钮
        {
            timertemp4.Start();
            if (spPower.IsOpen)
            {

                textBox27.Text = "";
                fx[0] = 0x7e;
                fx[1] = Convert.ToByte((2 / 16) + 0x30);
                fx[2] = Convert.ToByte((2 % 16) + 0x30);
                fx[3] = Convert.ToByte((2 / 16) + 0x30);
                fx[4] = Convert.ToByte((2 % 16) + 0x30);
                fx[5] = CID1_h;
                fx[6] = CID1_l;

                fx[7] = start_h;
                fx[8] = start_l;

                fx[9] = 0x30;
                fx[10] = 0x30;
                fx[11] = 0x30;
                fx[12] = 0x30;
                int c;

                for (c = 1; c < 13; c++)
                {
                    he += fx[c];
                }
                chekN(he);
                fx[13] = chksum[0];
                fx[14] = chksum[1];
                fx[15] = chksum[2];
                fx[16] = chksum[3];
                fx[17] = 0x0d;
                for (c = 0; c < 18; c++)
                {
                    textBox27.Text += " " + fx[c].ToString("x");
                }
                he = 0;
                spPower.Write(fx, 0, 18);

            }
            else
            {

                label91.ForeColor = Color.Red;
                label91.Text = "串口未打开！"; }
        }

        private void button3_Click(object sender, EventArgs e) // 停止
        {
            timertemp4.Start();
            if (spPower.IsOpen)            
            {

                textBox27.Text = "";
                fx[0] = 0x7e;
                fx[1] = Convert.ToByte((2 / 16) + 0x30);
                fx[2] = Convert.ToByte((2 % 16) + 0x30);
                fx[3] = Convert.ToByte((2 / 16) + 0x30);
                fx[4] = Convert.ToByte((2 % 16) + 0x30);
                fx[5] = CID1_h;
                fx[6] = CID1_l;

                fx[7] = stop_h;
                fx[8] = stop_l;

                fx[9] = 0x30;
                fx[10] = 0x30;
                fx[11] = 0x30;
                fx[12] = 0x30;
                int c;

                for (c = 1; c < 13; c++)
                {
                    he += fx[c];
                }
                chekN(he);
                fx[13] = chksum[0];
                fx[14] = chksum[1];
                fx[15] = chksum[2];
                fx[16] = chksum[3];
                fx[17] = 0x0d;
                for (c = 0; c < 18; c++)
                {
                    textBox27.Text += " " + fx[c].ToString("x");
                }
                he = 0;
                spPower.Write(fx, 0, 18);
            }
            else
            {
                label91.ForeColor = Color.Red;
                label91.Text = "串口未打开！"; }
        }

        private void button4_Click(object sender, EventArgs e)  //输出回读
        {
            timertemp4.Start();
            if (spPower.IsOpen)        
            {

                textBox27.Text = "";
                fx[0] = 0x7e;
                fx[1] = Convert.ToByte((2 / 16) + 0x30);
                fx[2] = Convert.ToByte((2 % 16) + 0x30);
                fx[3] = Convert.ToByte((2 / 16) + 0x30);
                fx[4] = Convert.ToByte((2 % 16) + 0x30);
                fx[5] = CID1_h;
                fx[6] = CID1_l;

                fx[7] = dispall_h;
                fx[8] = dispall_l;

                fx[9] = 0x30;
                fx[10] = 0x30;
                fx[11] = 0x30;
                fx[12] = 0x30;           
                int c;

                for (c = 1; c < 13; c++)
                {
                    he += fx[c];
                }
                chekN(he);
                fx[13] = chksum[0];
                fx[14] = chksum[1];
                fx[15] = chksum[2];
                fx[16] = chksum[3];
                fx[17] = 0x0d;
                for (c = 0; c < 18; c++)
                {
                    textBox27.Text += " " + fx[c].ToString("x");
                }
                he = 0;
                spPower.Write(fx, 0, 18);
            }
            else
            {
                label91.ForeColor = Color.Red;
                label91.Text = "串口未打开！"; }
        }

        private void button7_Click(object sender, EventArgs e)  //电压上限设定
        {
            timertemp4.Start();
            if (spPower.IsOpen & (textBox29.Text != ""))
            {

                textBox27.Text = "";
                fx[0] = 0x7e;                             
                fx[1] = Convert.ToByte((2 / 16) + 0x30);
                fx[2] = Convert.ToByte((2 % 16) + 0x30);
                fx[3] = Convert.ToByte((2 / 16) + 0x30);
                fx[4] = Convert.ToByte((2 % 16) + 0x30);
                fx[5] = CID1_h;
                fx[6] = CID1_l;

                fx[7] = upvolt_h;
                fx[8] = upvolt_l;

                fx[9] = 0x43;
                fx[10] = 0x30;
                fx[11] = 0x30;
                fx[12] = 0x34;
               
                upvolt = textBox29.Text;
                if (Convert.ToInt32(upvolt) <= 999)
                {
                   vlh = upvolt.Substring(0,1);
                   vll = upvolt.Substring(1,2);
                   fx[13] = 48;
                   fx[14] = Convert.ToByte(Convert.ToInt32(vlh)+48);
                   fx[15] = Convert.ToByte(Convert.ToInt32(vll.Substring(0,1)) + 48);
                   fx[16] = Convert.ToByte(Convert.ToInt32(vll.Substring(1,1)) + 48);
                }
                else
                {
                    vlh = upvolt.Substring(0,2);
                    vll = upvolt.Substring(2,2);
              
                    fx[13] = Convert.ToByte(Convert.ToInt32(vlh.Substring(0, 1)) + 48);
                    fx[14] = Convert.ToByte(Convert.ToInt32(vlh.Substring(1, 1)) + 48);
                    fx[15] = Convert.ToByte(Convert.ToInt32(vll.Substring(0, 1)) + 48);
                    fx[16] = Convert.ToByte(Convert.ToInt32(vll.Substring(1, 1)) + 48);
                }
                for (int c = 1; c < 17; c++)
                {
                    he += fx[c];
                }
                chekN(he);
                fx[17] = chksum[0];
                fx[18] = chksum[1];
                fx[19] = chksum[2];
                fx[20] = chksum[3];
                fx[21] = 0x0d;
                for (int c = 0; c < 22; c++)
                {
                    textBox27.Text += " " + fx[c].ToString("x");
                }
                he = 0;
                spPower.Write(fx, 0, 22);
                Vs = 1;
                Bs = 1;
            }
            else
            {
                System.DateTime vv = System.DateTime.Now;
                string vvv = vv.ToString("HH:mm:ss");
                if (textBox29.Text != "")
                {
                    label91.ForeColor = Color.Red;
                   
                    label91.Text = vvv + " 串口未打开！";
                }
                else
                {
                    label91.ForeColor = Color.LimeGreen;
                    label91.Text = vvv + " 电压上限输入不能为空！";
                }
            }
        }

        private void button10_Click(object sender, EventArgs e)  //电流上限设定
        {
            timertemp4.Start();
            if (spPower.IsOpen&(textBox30.Text!=""))
            {

                textBox27.Text = "";
                fx[0] = 0x7e;                             
                fx[1] = Convert.ToByte((2 / 16) + 0x30);
                fx[2] = Convert.ToByte((2 % 16) + 0x30);
                fx[3] = Convert.ToByte((2 / 16) + 0x30);
                fx[4] = Convert.ToByte((2 % 16) + 0x30);
                fx[5] = CID1_h;
                fx[6] = CID1_l;

                fx[7] = upcurr_h;
                fx[8] = upcurr_l;

                fx[9] = 0x43;
                fx[10] = 0x30;
                fx[11] = 0x30;
                fx[12] = 0x34;

                upvolt = Convert.ToString(Convert.ToInt32(textBox30.Text)*10);
                if (Convert.ToInt32(upvolt) <= 999)
                {
                    vlh = upvolt.Substring(0, 1);
                    vll = upvolt.Substring(1, 2);
                    fx[13] = 48;
                    fx[14] = Convert.ToByte(Convert.ToInt32(vlh) + 48);
                    fx[15] = Convert.ToByte(Convert.ToInt32(vll.Substring(0, 1)) + 48);
                    fx[16] = Convert.ToByte(Convert.ToInt32(vll.Substring(1, 1)) + 48);
                }
                else
                {
                    vlh = upvolt.Substring(0, 2);
                    vll = upvolt.Substring(2, 2);
                    fx[13] = Convert.ToByte(Convert.ToInt32(vlh.Substring(0, 1) )+ 48);
                    fx[14] = Convert.ToByte(Convert.ToInt32(vlh.Substring(1, 1) )+ 48);
                    fx[15] = Convert.ToByte(Convert.ToInt32(vll.Substring(0, 1) )+ 48);
                    fx[16] = Convert.ToByte(Convert.ToInt32(vll.Substring(1, 1) )+ 48);
                }
                for (int c = 1; c < 17; c++)
                {
                    he += fx[c];
                }
                chekN(he);
                fx[17] = chksum[0];
                fx[18] = chksum[1];
                fx[19] = chksum[2];
                fx[20] = chksum[3];
                fx[21] = 0x0d;
                for (int c = 0; c < 22; c++)
                {
                    textBox27.Text += " " + fx[c].ToString("x");
                }
                he = 0;
                spPower.Write(fx, 0, 22);
                Vs = 1;
                Bs = 1;
            }
            else
            {
                System.DateTime vv = System.DateTime.Now;
                string vvv = vv.ToString("HH:mm:ss");
                if (textBox30.Text != "")
                {
                    label91.ForeColor = Color.Red;

                    label91.Text = vvv + " 串口未打开！";
                }
                else
                {
                    label91.ForeColor = Color.LimeGreen;
                    label91.Text = vvv + " 电流上限输入不能为空！";
                }
            }
        }
        private void button11_Click(object sender, EventArgs e) // 电压输出
        {
            timertemp4.Start();

            if (spPower.IsOpen & (textBox41.Text != "") & ((textBox30.Text != "") | (textBox29.Text != "")))
            {
                if ((upvolt != null) && (Bs == 1) && (Convert.ToInt32(textBox41.Text) - Convert.ToDouble(label17.Text) <= 500))
                {
                    textBox27.Text = "";
                    fx[0] = 0x7e;
                    fx[1] = Convert.ToByte((2 / 16) + 0x30);
                    fx[2] = Convert.ToByte((2 % 16) + 0x30);
                    fx[3] = Convert.ToByte((2 / 16) + 0x30);
                    fx[4] = Convert.ToByte((2 % 16) + 0x30);
                    fx[5] = CID1_h;
                    fx[6] = CID1_l;

                    fx[7] = prevolt_h;
                    fx[8] = prevolt_l;

                    fx[9] = 0x43;
                    fx[10] = 0x30;
                    fx[11] = 0x30;
                    fx[12] = 0x34;

                    upvolt = textBox41.Text;
                    if (Convert.ToInt32(upvolt) <= 999)
                    {
                        vlh = upvolt.Substring(0, 1);
                        vll = upvolt.Substring(1, 2);
                        fx[13] = 48;
                        fx[14] = Convert.ToByte(Convert.ToInt32(vlh) + 48);
                        fx[15] = Convert.ToByte(Convert.ToInt32(vll.Substring(0, 1)) + 48);
                        fx[16] = Convert.ToByte(Convert.ToInt32(vll.Substring(1, 1)) + 48);
                    }
                    else
                    {
                        vlh = upvolt.Substring(0, 2);
                        vll = upvolt.Substring(2, 2);
                        fx[13] = Convert.ToByte(Convert.ToInt32(vlh.Substring(0, 1)) + 48);
                        fx[14] = Convert.ToByte(Convert.ToInt32(vlh.Substring(1, 1)) + 48);
                        fx[15] = Convert.ToByte(Convert.ToInt32(vll.Substring(0, 1)) + 48);
                        fx[16] = Convert.ToByte(Convert.ToInt32(vll.Substring(1, 1)) + 48);
                    }
                    for (int c = 1; c < 17; c++)
                    {
                        he += fx[c];
                    }
                    chekN(he);
                    fx[17] = chksum[0];
                    fx[18] = chksum[1];
                    fx[19] = chksum[2];
                    fx[20] = chksum[3];
                    fx[21] = 0x0d;
                    for (int c = 0; c < 22; c++)
                    {
                        textBox27.Text += " " + fx[c].ToString("x");
                    }
                    he = 0;
                   
                    spPower.Write(fx, 0, 22);
                    Vs = 1;

                }
                else
                {
                    if (Bs != 1)
                    {
                        label91.ForeColor = Color.LimeGreen;
                        label91.Text = "请先设置电压或电流上限";//"调整范围过大！（500以内）";
                    }
                    else
                    {
                        MessageBox.Show("调整范围过大！（500以内）");
                    }  
                }
            }
            else
            {
                System.DateTime vv = System.DateTime.Now;
                string vvv = vv.ToString("HH:mm:ss");
                if ((textBox30.Text != "")||(textBox29.Text != ""))
                {
                    label91.ForeColor = Color.Red;
                    label91.Text = vvv+" 串口未打开！"; }
                else
                {
                    label91.ForeColor = Color.LimeGreen;
                label91.Text = vvv+" 请设置电压或电流上限！";
                
                  }
                }
        }
        private void button13_Click(object sender, EventArgs e)  // 退出
        {
            panel1.Hide();
           
            spPower.Close();
        }

        private void button14_Click(object sender, EventArgs e)  //状态回读
        {
            timertemp4.Start();
            if (spPower.IsOpen)
            {

                textBox27.Text = "";
                fx[0] = 0x7e;
                fx[1] = Convert.ToByte((2 / 16) + 0x30);
                fx[2] = Convert.ToByte((2 % 16) + 0x30);
                fx[3] = Convert.ToByte((2 / 16) + 0x30);
                fx[4] = Convert.ToByte((2 % 16) + 0x30);
                fx[5] = CID1_h;
                fx[6] = CID1_l;

                fx[7] = state_h;
                fx[8] = state_l;

                fx[9] = 0x30;
                fx[10] = 0x30;
                fx[11] = 0x30;
                fx[12] = 0x30;
                int c;

                for (c = 1; c < 13; c++)
                {
                    he += fx[c];
                }
                chekN(he);
                fx[13] = chksum[0];
                fx[14] = chksum[1];
                fx[15] = chksum[2];
                fx[16] = chksum[3];
                fx[17] = 0x0d;
                for (c = 0; c < 18; c++)
                {
                    textBox27.Text += " " + fx[c].ToString("x");
                }
                he = 0;
                spPower.Write(fx, 0, 18);



            }
            else
            {
                System.DateTime vv = System.DateTime.Now;
                string vvv = vv.ToString("HH:mm:ss");
                label91.ForeColor = Color.Red;
                label91.Text = vvv+" 串口未打开！"; }
        }
        private void button17_Click(object sender, EventArgs e) //自动回读
        {
            if ( button17.Text == "自动回读")
            {
                button17.Text = "关闭回读";
                timertemp6.Start();
            }
            else
            {
                button17.Text = "自动回读";
                timertemp6.Close();
            }
        }
        private void button18_Click(object sender, EventArgs e)//锁定按键
        {
            if (button18.Text == "锁定按键")
            {
                button18.Text = "解除锁定";
                button7.Enabled = false;
                button10.Enabled = false;
                button11.Enabled = false;
                button4.Enabled = false;
               
                button14.Enabled = false;
                button3.Enabled = false;
                button17.Enabled = false;
                textBox29.Enabled = false;
                textBox30.Enabled = false;
                textBox41.Enabled = false;

            }
            else
            {
                button18.Text = "锁定按键";
                button7.Enabled =true;
                button10.Enabled = true;
                button11.Enabled = true;
                button4.Enabled = true;
                
                button14.Enabled = true;
                button3.Enabled = true;
                button17.Enabled = true;
                textBox29.Enabled = true;
                textBox30.Enabled = true;
                textBox41.Enabled = true;
            }
        }
        #endregion 按键设置
        #endregion 程控电源
        #region 绝缘检测
        #region 串口配置
        public SerialPort spbender = new SerialPort();
        public string status3;
        public string[] dd = new string[22];
       // private StringBuilder builder_1 = new StringBuilder();//避免在事件处理方法中反复的创建，定义到外面。

        public void port_spbenderint()
        {

            spbender.DataReceived += new SerialDataReceivedEventHandler(spbender_DataReceived);

        }
        public void startBender()
        {
            if (!spbender.IsOpen)
            {
                string portname = comboBox3.Text; int baudrate = 9600; int databits = 8; Parity parity = Parity.None; StopBits stopbits = StopBits.One;
                spbender.PortName = portname;
                spbender.BaudRate = baudrate;
                spbender.DataBits = databits;
                spbender.Parity = parity;
                spbender.StopBits = stopbits;
                spbender.DtrEnable = true;//若不定义 串口监听不能使
                spbender.RtsEnable = true;//若不定义 串口监听不能使
                //spPower.ReadTimeout = 1000;
                try
                {
                    spbender.Open();
                    toolStripStatusLabel1.Text = "串口启动成功";
                }
                catch (Exception error)
                {
                    MessageBox.Show(error.Message);
                }

            }
        }
        #endregion 串口配置
        #region 数据解析
        private void spbender_DataReceived(object sender, SerialDataReceivedEventArgs e)
        {
            string k1=""; string k2=""; string k3="";
            Thread.Sleep(500);
            int bn = spbender.BytesToRead;
            byte[] bS = new byte[bn];
            spbender.Read(bS, 0, bn);
            //builder_1.Clear();
            if (bn > 31)
            {
                if ((bS[1] == 0x0f) & (bS[31] == 0x0d) & (bS[30] == 0x0a))
                {
                    //this.Invoke((EventHandler)(delegate
                    //{
                    //    builder_1.Append(Encoding.ASCII.GetString(bS));
                    //    string ss;
                    //    ss = byteToHexStr(bS);
                    //    this.textBox52.AppendText(ss);
                    //}));
                    for (int p = 2; p < 8; p++)
                    {
                        k1 += Convert.ToString((char)Convert.ToInt16(bS[p]));
                    }
                    textBox48.Text = k1;
                    for (int p = 9; p < 15; p++)
                    {
                        k2 += Convert.ToString((char)Convert.ToInt16(bS[p]));
                    }
                    textBox51.Text = k2;
                    for (int p = 16; p < 22; p++)
                    {
                        k3 += Convert.ToString((char)Convert.ToInt16(bS[p]));
                    }
                   textBox50.Text = k3;
                    switch (bS[23])
                    {
                        case 0x30: label84.Text = "K1-off & K2-off"; break;
                        case 0x31: label84.Text = "K1-on & K2-off"; break;
                        case 0x32: label84.Text = "K1-off & K2-on"; break;
                        case 0x33: label84.Text = "K1-on & K2-on"; break;

                    }
                    switch (bS[25])
                    {
                        case 0x30: label85.Text = "No alarm"; break;
                        case 0x31: label85.Text = "Alarm-1"; break;
                        case 0x32: label85.Text = "Alarm-2"; break;
                        case 0x33: label85.Text = "Alarm-1/2"; break;

                    }
                    switch (bS[27])
                    {
                        case 0x30: label87.Text = "AC fault"; break;
                        case 0x31: label87.Text = "DC- fault"; break;
                        case 0x32: label87.Text = "DC+ fault"; break;


                    }
                    System.DateTime currentTime = System.DateTime.Now;
                    string strYMD = currentTime.ToString("MMdd HH:mm:ss");
                    string strYMD1 = currentTime.ToString("MMdd");
                    if (!File.Exists("D:\\bender\\bender_" + strYMD1 + ".txt"))
                    {
                        FileStream bender = new FileStream(("D:\\bender\\bender_" + strYMD1 + ".txt"), FileMode.Create, FileAccess.Write);
                        StreamWriter ben = new StreamWriter(bender);
                        ben.WriteLine("时间--" + "\t" + "阻值" + "\t" + "阻值上限" + "\t" + "阻值下限" + "\t" + "开关状态" + "\t" + "报警" + "\t" + "错误" + "\t");
                        ben.Close();
                        bender.Close();
                    }
                    else
                    {
                        FileStream bender = new FileStream(("D:\\bender\\bender_" + strYMD1 + ".txt"), FileMode.Append, FileAccess.Write);
                        StreamWriter ben = new StreamWriter(bender);
                        ben.WriteLine(strYMD+"\t"+textBox48.Text+"\t"+textBox50.Text+"\t"+textBox51.Text+"\t"+label84.Text+"\t"+label85+"\t"+label87+"\t");
                        ben.Close();
                        bender.Close();
                    }

                }

                zedGraphControl2.GraphPane.XAxis.Scale.MaxAuto = true;
                double x = (double)new XDate(DateTime.Now);
                double y = Convert.ToDouble(textBox48.Text);
                if (list1.Count >= 200)
                {
                    list1.RemoveAt(0);
                }
                list1.Add(x, y);
                this.zedGraphControl2.AxisChange();
                this.zedGraphControl2.Refresh();
                
            }
        
        
        }
        #endregion 数据解析
        private void button15_Click(object sender, EventArgs e)
        {
            if (button15.Text == "开启串口")
            {
                textBox48.Text = ""; textBox50.Text = ""; textBox51.Text = "";
                startBender();
                button15.Text = "关闭串口";
                comboBox3.Enabled = false;
            }

            else
            {
                if (zedGraphControl2.Visible == true)
                {
                    MessageBox.Show("请先关闭曲线图！");
                }
                else
                {
                    button15.Text = "开启串口";
                    spbender.Close();
                    comboBox3.Enabled = true;
                }
            }
        }
        #endregion 绝缘检测
        #region 温度曲线
        private void 温度曲线ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (zedGraphControl1.Visible == false)
            { 
                zedGraphControl1.Show();
                timer1.Start();

            }
            else
            {
                timer1.Stop();
                zedGraphControl1.Hide();
            }
            
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
           
            zedGraphControl1.GraphPane.XAxis.Scale.MaxAuto = true;
            double x = (double)new XDate(DateTime.Now);
            double y = Convert.ToDouble(textBox36.Text);
            if (list.Count >= 200)
            {
                list.RemoveAt(0);
            }
            list.Add(x, y);
            this.zedGraphControl1.AxisChange();
            this.zedGraphControl1.Refresh();
        }

        #endregion 温度曲线
        #region 绝缘阻值曲线
        private void button16_Click(object sender, EventArgs e)  //曲线图
        {
            if (zedGraphControl2.Visible == false)
            {
                zedGraphControl2.Show();
               

            }
            else
            {
              
                zedGraphControl2.Hide();
            }
            

        }
        private void timer2_Tick(object sender, EventArgs e)
        {
            zedGraphControl2.GraphPane.XAxis.Scale.MaxAuto = true;
            double x = (double)new XDate(DateTime.Now);
            double y = Convert.ToDouble(textBox48.Text);
            if (list1.Count >= 200)
            {
                list1.RemoveAt(0);
            }
            list1.Add(x, y);
            this.zedGraphControl2.AxisChange();
            this.zedGraphControl2.Refresh();
        }

        #endregion 绝缘阻值曲线


        public delegate void withyou(string name);
        public class fuckyou
        {
            public event withyou kk;
            public void greet(string name)
            {
                kk(name);
            }
        
        }

        private void button19_Click(object sender, EventArgs e)
        {
            panel1.Hide();
        }
        

    }
}